// ConfigSound.cpp :  Դϴ.
//

#include "stdafx.h"
#include "NeMessenger.h"
#include "ConfigSound.h"
#include "ConfigBasic.h"

// CConfigSound ȭ Դϴ.

IMPLEMENT_DYNAMIC(CConfigSound, CConfigBaseDlg)

CConfigSound::CConfigSound(CWnd* pParent /*=NULL*/)
: CConfigBaseDlg(CConfigSound::IDD, pParent)
{
	m_rcTitleText.SetRect(20,27,100,49);
	m_rcOnButton.SetRect(108,29,119,46);
	m_rcOnText.SetRect(123,27,184,49);
	m_rcOffButton.SetRect(184,29,195,46);
	m_rcOffText.SetRect(199,27,262,49);

	m_nAllSound = 0;
	m_nNoteSound = 0;
	m_nChatSound = 0;
	m_nTraySound = 0;
	m_nSystemSound= 0;
    m_rcNoteSoundOn.SetRectEmpty();
    m_rcNoteSoundOff.SetRectEmpty();
    m_rcChatSoundOn.SetRectEmpty();
    m_rcChatSoundOff.SetRectEmpty();

	m_bFirstRun = TRUE;
}

CConfigSound::~CConfigSound()
{
}

void CConfigSound::DoDataExchange(CDataExchange* pDX)
{
	CConfigBaseDlg::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_RADIO_ALL_SOUND_ON, m_rdAllSoundOn);
	DDX_Control(pDX, IDC_RADIO_ALL_SOUND_OFF, m_rdAllSoundOff);
	DDX_Radio(pDX, IDC_RADIO_ALL_SOUND_ON, m_nAllSound);

	DDX_Control(pDX, IDC_RADIO_NOTE_SOUND_ON, m_rdNoteSoundOn);
	DDX_Control(pDX, IDC_RADIO_NOTE_SOUND_OFF, m_rdNoteSoundOff);
	DDX_Radio(pDX, IDC_RADIO_NOTE_SOUND_ON, m_nNoteSound);

	DDX_Control(pDX, IDC_RADIO_CHAT_SOUND_ON, m_rdChatSoundOn);
	DDX_Control(pDX, IDC_RADIO_CHAT_SOUND_OFF, m_rdChatSoundOff);
	DDX_Radio(pDX, IDC_RADIO_CHAT_SOUND_ON, m_nChatSound);

	DDX_Control(pDX, IDC_RADIO_TRAY_SOUND_ON, m_rdTraySoundOn);
	DDX_Control(pDX, IDC_RADIO_TRAY_SOUND_OFF, m_rdTraySoundOff);
	DDX_Radio(pDX, IDC_RADIO_TRAY_SOUND_ON, m_nTraySound);

	DDX_Control(pDX, IDC_RADIO_SYSTEM_SOUND_ON, m_rdSystemSoundOn);
	DDX_Control(pDX, IDC_RADIO_SYSTEM_SOUND_OFF, m_rdSystemSoundOff);
	DDX_Radio(pDX, IDC_RADIO_SYSTEM_SOUND_ON, m_nSystemSound);
}


BEGIN_MESSAGE_MAP(CConfigSound, CConfigBaseDlg)

	ON_WM_ERASEBKGND()
END_MESSAGE_MAP()


void CConfigSound::DoApply()
{
	UpdateData(TRUE);
	/*GET_CONFIG()->SetAllSound( (m_nAllSound == 0) ? 1:0 );
	GET_CONFIG()->SetNoteSound((m_nNoteSound == 0) ? 1:0); 
	GET_CONFIG()->SetChatSound((m_nChatSound == 0) ? 1:0);
	GET_CONFIG()->SetTraySound((m_nTraySound == 0) ? 1:0);
	GET_CONFIG()->SetSystemSound((m_nSystemSound == 0) ? 1:0);*/
}

void CConfigSound::initData()
{

	/*m_nAllSound = (GET_CONFIG()->GetAllSound() == 1) ? 0:1;
	m_nNoteSound = (GET_CONFIG()->GetNoteSound() == 1) ? 0:1;
	m_nChatSound = (GET_CONFIG()->GetChatSound() == 1) ? 0:1;
	m_nTraySound = (GET_CONFIG()->GetTraySound() == 1) ? 0:1;
	m_nSystemSound = (GET_CONFIG()->GetSystemSound() == 1) ? 0:1;*/
	UpdateData(FALSE);
}

BOOL CConfigSound::OnInitDialog()
{
	CConfigBaseDlg::OnInitDialog();	
	m_bFirstRun = TRUE;
	CRect rcOffButton =	   m_rcOffButton;
	CRect rcOnButton = m_rcOnButton;

	//this->GetDlgItem(IDC_RADIO_ALL_SOUND_ON)->MoveWindow(rcOnButton,TRUE);
	//this->GetDlgItem(IDC_RADIO_ALL_SOUND_OFF)->MoveWindow(rcOffButton,TRUE);
	//rcOnButton.OffsetRect(0, CONFIG_SOUND_CONTROL_GAP);
	//rcOffButton.OffsetRect(0, CONFIG_SOUND_CONTROL_GAP);

	this->GetDlgItem(IDC_RADIO_NOTE_SOUND_ON)->MoveWindow(rcOnButton,TRUE);
	this->GetDlgItem(IDC_RADIO_NOTE_SOUND_OFF)->MoveWindow(rcOffButton,TRUE);
	rcOnButton.OffsetRect(0, CONFIG_SOUND_CONTROL_GAP);
	rcOffButton.OffsetRect(0, CONFIG_SOUND_CONTROL_GAP);

	this->GetDlgItem(IDC_RADIO_CHAT_SOUND_ON)->MoveWindow(rcOnButton,TRUE);
	this->GetDlgItem(IDC_RADIO_CHAT_SOUND_OFF)->MoveWindow(rcOffButton,TRUE);
	rcOnButton.OffsetRect(0, CONFIG_SOUND_CONTROL_GAP);
	rcOffButton.OffsetRect(0, CONFIG_SOUND_CONTROL_GAP);

	this->GetDlgItem(IDC_RADIO_TRAY_SOUND_ON)->MoveWindow(rcOnButton,TRUE);
	this->GetDlgItem(IDC_RADIO_TRAY_SOUND_OFF)->MoveWindow(rcOffButton,TRUE);
	rcOnButton.OffsetRect(0, CONFIG_SOUND_CONTROL_GAP);
	rcOffButton.OffsetRect(0, CONFIG_SOUND_CONTROL_GAP);

	this->GetDlgItem(IDC_RADIO_SYSTEM_SOUND_ON)->MoveWindow(rcOnButton,TRUE);
	this->GetDlgItem(IDC_RADIO_SYSTEM_SOUND_OFF)->MoveWindow(rcOffButton,TRUE);
	rcOnButton.OffsetRect(0, CONFIG_SOUND_CONTROL_GAP);
	rcOffButton.OffsetRect(0, CONFIG_SOUND_CONTROL_GAP);

	initData();
	return TRUE;
}

BOOL CConfigSound::OnEraseBkgnd(CDC* pDC)
{
	BOOL bRet = CConfigBaseDlg::OnEraseBkgnd(pDC);
	CRect rcTitle = m_rcTitleText;
	CFont *pOldFont = pDC->SelectObject(&g_ftDefault10PT);
	COLORREF oldColor = pDC->SetTextColor(CONFIG_SOUND_TITLE_TEXT_COLOR);

	//pDC->SetBkMode(TRANSPARENT);
	//pDC->DrawText(L"ü ",rcTitle,DT_LEFT);
	//rcTitle.OffsetRect(0, CONFIG_SOUND_CONTROL_GAP);

	pDC->DrawText(LoadStringFromResource(IDS_STRING417),rcTitle,DT_LEFT);
	rcTitle.OffsetRect(0, CONFIG_SOUND_CONTROL_GAP);

	pDC->DrawText(LoadStringFromResource(IDS_STRING252),rcTitle,DT_LEFT);
	rcTitle.OffsetRect(0, CONFIG_SOUND_CONTROL_GAP);

	//pDC->DrawText(L"Ʈ ˸",rcTitle,DT_LEFT);
	//rcTitle.OffsetRect(0, CONFIG_SOUND_CONTROL_GAP);

	//pDC->DrawText(L"ý ˸",rcTitle,DT_LEFT);
	//rcTitle.OffsetRect(0, CONFIG_SOUND_CONTROL_GAP);


	CRect rcOnText = m_rcOnText;
	pDC->SelectObject(&g_ftDefault9PT);
	pDC->SetTextColor(CONFIG_SOUND_BASIC_TEXT_COLOR);

	//pDC->DrawText(L" ü ѱ",rcOnText,DT_LEFT);
	//rcOnText.OffsetRect(0, CONFIG_SOUND_CONTROL_GAP);

	pDC->DrawText(LoadStringFromResource(IDS_STRING579),rcOnText,DT_LEFT);
	m_rcNoteSoundOn = rcOnText;
	rcOnText.OffsetRect(0, CONFIG_SOUND_CONTROL_GAP);

	pDC->DrawText(LoadStringFromResource(IDS_STRING579),rcOnText,DT_LEFT);
	m_rcChatSoundOn = rcOnText;
	rcOnText.OffsetRect(0, CONFIG_SOUND_CONTROL_GAP);

//	pDC->DrawText(L" ѱ",rcOnText,DT_LEFT);
	rcOnText.OffsetRect(0, CONFIG_SOUND_CONTROL_GAP);

	//pDC->DrawText(L" ѱ",rcOnText,DT_LEFT);
	rcOnText.OffsetRect(0, CONFIG_SOUND_CONTROL_GAP);

	CRect rcOffText = m_rcOffText;

	//pDC->DrawText(L" ü ",rcOffText,DT_LEFT);
	//rcOffText.OffsetRect(0, CONFIG_SOUND_CONTROL_GAP);

	pDC->DrawText(LoadStringFromResource(IDS_STRING580),rcOffText,DT_LEFT);
	m_rcNoteSoundOff = rcOffText;
	rcOffText.OffsetRect(0, CONFIG_SOUND_CONTROL_GAP);

	pDC->DrawText(LoadStringFromResource(IDS_STRING580),rcOffText,DT_LEFT);
	m_rcChatSoundOff = rcOffText;
	rcOffText.OffsetRect(0, CONFIG_SOUND_CONTROL_GAP);

	//pDC->DrawText(L" ",rcOffText,DT_LEFT);
	rcOffText.OffsetRect(0, CONFIG_SOUND_CONTROL_GAP);

	//pDC->DrawText(L" ",rcOffText,DT_LEFT);
	rcOffText.OffsetRect(0, CONFIG_SOUND_CONTROL_GAP);

	
	if (m_bFirstRun)
	{
		AddClickAssociateInfo(&m_rdNoteSoundOn, m_rcNoteSoundOn);
		AddClickAssociateInfo(&m_rdNoteSoundOff, m_rcNoteSoundOff);
		AddClickAssociateInfo(&m_rdChatSoundOn, m_rcChatSoundOn);
		AddClickAssociateInfo(&m_rdChatSoundOff, m_rcChatSoundOff);
		m_bFirstRun = FALSE;
	}


	return bRet;
}

BOOL CConfigSound::PreTranslateMessage(MSG* pMsg)
{
	if(pMsg->message == WM_KEYDOWN)
	{
		if(pMsg->wParam == VK_ESCAPE)
		{
			return TRUE;
		}
		else if(pMsg->wParam == VK_RETURN)
		{			
			return TRUE;
		}
	}
	else if(pMsg->message == WM_CLOSE)
	{
		OnOK();
		return TRUE;
	}

	return __super::PreTranslateMessage(pMsg);
}
